%This function calculates the lateral error from the track of your car.  It
%accepts the position of the car in meters and returns the error also in
%meters.  Valid inputs for x and y can be any value.  The
%direction the car should travel is clockwise.

function err_out = track_2011(x,y,xdot,ydot)

if x < 0 
	r1=  sqrt((x)^2+(y-(-1.7))^2); % distance from center of circle  
	e =  r1- 1.7;
        rhat = [x y+1.7]/norm([x y+1.7]);
    edot = rhat*[xdot ydot]';

elseif (x >= 0 & x <= 3 & y >= -1)
    e = y;
    edot = ydot;
elseif (x > 3 & x <= 6 & y >= -1)
    e = y - 0.1;
    edot = ydot;
elseif (x > 6 && y >=-1)
    e = (sqrt((x-6)^2+(y-(-1))^2) - 1.1);
     rhat = [x-6 y+1]/norm([x-6 y+1]);
    edot = rhat*[xdot ydot]';

elseif (x > 6 && y < -1 && y >= -5.4)
    e = x - 7.1;
    edot = xdot;
    
elseif (y<-5.4)
    e = (sqrt((x-5.8)^2+(y-(-5.4))^2) - 1.3);
     rhat = [x-5.8 y+5.4]/norm([x-5.8 y+5.4]);
    edot = rhat*[xdot ydot]';
    
elseif ((x >=2.5 && x <= 6 && y < -1 && y >= -5.4))
    e = -(sqrt((x-2.5)^2+(y-(-5.4))^2) - 2); 
    rhat = [x-2.5 y+5.4]/norm([x-2.5 y+5.4]);
    edot = -rhat*[xdot ydot]';
    
elseif (x >=0 & x <= 2.5 & y < -1)
    e = -y - 3.4;
    edot = -ydot;
    
end

err_out = [e, edot];











